///Browser Language Version 1; Reference Guide.
Browser Language Version 1
Reference Guide
-------------------------------------------------------------------------------
Dedicated to the public domain
This document (c)1995, David Turgeon and Pyroxyde Industries.
All Rights Reserved.


//noprint on
Specific Reference:
Variables  //goto :var
Commands  //goto :cmd
Functions  //goto :func
Error messages  //goto :error

External Reference:
Browser Documentation  //goto doc.b
Introduction to Browser  //goto intro.b

Search a specific topic (Variable, Command or Function):
Enter topic here: //input topic, 15, 0, 1
Start search  //goto :&&(topic)

If you want instant help from DOS prompt, use the following format:
    b ref:<topic>
//savepos
//set topic
//push
//end
//noprint off

//ff
//:var
Variables
-------------------------------------------------------------------------------


blink       Link background color
blinkbar    Link bar background color
bnorm       Normal background color
bnormbar    Normal bar background color
emptycmd    Empty command line flag
file        Currently loading filename
flink       Link foreground color
flinkbar    Link bar foreground color
fnorm       Normal foreground color
fnormbar    Normal bar foreground color
fulllink    Currently loading filename and link
link        Currently loading link
savefile    Currently saving filename
ver         Browser Language version
wx1         Window row coordinate for upper left corner
wx2         Window row coordinate for lower right corner 
wy1         Window column coordinate for upper left corner
wy2         Window column coordinate for lower right corner
//end var

//ff
//:cmd
Commands
-------------------------------------------------------------------------------


c           Enables or disables automatic centering of text //goto :c
            when loading. //goto :c
center      Centers a string in the screen. //goto :center
clreol      Clears to the end of line. //goto :clreol
clrscreen   Clears the screen. //goto :clrscreen
color       Sets the current color attribute. //goto :color
cr          Makes a carriage return. //goto :cr
dec         Decrements a variable. //goto :dec
edit        Marks a text line as editable. //goto :edit
end         Ends loading of a link. //goto :end
exec        Executes a command line. //goto :exec
goto        Marks the current line as linked. //goto :goto
if          Executes a command depending on a boolean expression. //goto :if
inc         Increments a variable. //goto :inc
input       Marks the current text line as an input line using //goto :input
            specified parameters. //goto :input
locase      Converts a variable value into lower case. //goto :locase
locate      Sets the current cursor position. //goto :locate
pop         Pops a link name out of the stack. //goto :pop
push        Pushes a link name into the stack. //goto :push
quit        Quits the Browser interpreter or marks the current //goto :quit
            line as a quitting line. //goto :quit
readkey     Waits for a keypress and puts the key into the specified //goto :readkey
            variable. //goto :readkey
run         Runs a subprocess. //goto :run
savepos     Marks the current link in the position-saving mode. //goto :savepos
set         Sets the value of a specified variable. //goto :set
setcolor    Sets the current reader interface colors. //goto :setcolor
setcr       Sets a trap link for the Enter (CR) key. //goto :setcr
setesc      Sets a trap link for the Escape key. //goto :setesc
setloadproc Sets the text loading command. //goto :setloadproc
setsaveproc Sets the text saving command. //goto :setsaveproc
string      Echoes a string of characters to the screen. //goto :string
submit      Marks the current line as a submitting line. //goto :submit
upcase      Converts a variable value into upper case. //goto :upcase
window      Sets the current window coordinates. //goto :window
write       Echoes a string expression to the screen. //goto :write
//savepos
//push
//end cmd

//ff
//:c
c
-------------------------------------------------------------------------------


    \\/c <boolean expression>

Enables or disables automatic centering of text when loading.

All text that comes after a "\\/c on" command will be automatically centered 
in accordance with the current window coordinates.  A "\\/c off" will disable 
this function.
//end c

//ff
//:center
center
-------------------------------------------------------------------------------


    \\/center <string expression>

Centers a string in the screen.

The text will be centered in accordance with the current window coordinates, 
on the current line.  This is very useful when creating an interface.

    \\/gotoxy 24, 1
    \\/string 80, '-'
    \\/gotoxy 25, 1
    \\/center 'Browser Interface'
//end center

//ff
//:clreol
clreol
-------------------------------------------------------------------------------


    \\/clreol

Clears to the end of line.

The rest of the line, starting from the current position, will be cleared 
using the current color attributes, in accordance with the window 
coordinates.

Related topics:
clrscreen //goto :clrscreen
color //goto :color
window //goto :window
//end clreol

//ff
//:clrscreen
clrscreen
-------------------------------------------------------------------------------


    \\/clrscreen

Clears the screen.

The whole screen will be cleared using the current color attributes, in 
accordance with the window coordinates.

Related topics:
clreol //goto :clreol
color //goto :color
window //goto :window
//end clrscreen

//ff
//:color
color
-------------------------------------------------------------------------------


    \\/color <foreground> <background>

Sets the current color attribute.

The foreground color can be one of those:

    0  Black        4  Red          8  Dark Grey    12 Light Red
    1  Blue         5  Magenta      9  Light Blue   13 Light Magenta
    2  Green        6  Brown        10 Light Green  14 Yellow
    3  Cyan         7  Light Grey   11 Light Cyan   15 White

The background color can be one of those:

    0  Black        2  Green        4  Red          6  Brown
    1  Blue         3  Cyan         5  Magenta      7  Light Grey

Related topics:
setcolor //goto :setcolor
//end color

//ff
//:cr
cr
-------------------------------------------------------------------------------


    \\/cr

Makes a carriage return.

Related topics:
string //goto :string
write //goto :write
//end cr

//ff
//:dec
dec
-------------------------------------------------------------------------------


    \\/dec <variable name>[, <decrementation>]

Decrements a variable.

If no decrementation is given, the variable value is decremented by 1.

Related topics:
inc //goto :inc
//end dec

//ff
//:edit
edit
-------------------------------------------------------------------------------


    <text> \\/edit

Marks a text line as editable.

When marked as editable, a user can select a line as if it was a normal link 
and edit it to suit his/her needs.  The edited text stays in memory until a 
new article is loaded.

    Please fill this infoform out.

    Name: \\/edit
    First name: \\/edit
    Address: \\/edit
    City: \\/edit
    State: \\/edit
    Zip: \\/edit

    Press here to write the infoform in INFOFORM.TXT \\/submit infoform.txt

Related topics:
input //goto :input
readkey //goto :readkey
submit //goto :submit
//end edit

//ff
//:end
end
-------------------------------------------------------------------------------


    \\/end [<link>]

Ends loading of a link.

Use the \\/end command whenever a link (article) is finished.  Using this 
command without a parameter means the finishing article is the unnamed one.
//end end

//ff
//:exec
exec
-------------------------------------------------------------------------------


    \\/exec <command line>

Executes a command line.

This command will interpret the command line as if it was written on the DOS 
prompt.  That is, it will search the program in the defined path, under 
possible extensions of .COM, .EXE and .BAT, in order.  In the case of a .BAT 
file (batch file), Browser will run the command interpreter and add the given 
command line as a parameter (with "/C").
//end exec

//ff
//:goto
goto
-------------------------------------------------------------------------------


    <text> \\/goto [<file>][:<link>][, <line>]

Marks the current line as linked.

When a user selects a line that has been marked as linked, control goes to 
the specified link and continues there.

The "goto" command can not be used as a branching command.

    Please select one of those:

    Some text in this very file \\/goto :text
    Some other text in another file \\/goto other:text

Related topics:
push //goto :push
//end goto

//ff
//:if
if
-------------------------------------------------------------------------------


    \\/if <boolean expression>, <command>
    \\/if <boolean expression>, <text>

Executes a command depending on a boolean expression.

This command is useful when used with functions that return a boolean 
expression (true, false, on, off, 0, 1).  If the expression is true, then the 
command is executed or the text is processed.

The \\&not function can be used in conjunction with this command when testing 
for a negative result.

    \\/if \\&equ(\\&(intrface), 2), \\/run :int_2
    \\/if \\&not(\\&equ(\\&(intrface), 3)), Interface Chosen is not 3.

Related topics:
equ //goto :equ
exist //goto :exist
not //goto :not
//end if

//ff
//:inc
inc
-------------------------------------------------------------------------------


    \\/inc <variable name>[, <incrementation>]

Increments a variable.

If no incrementation is given, the variable value is incremented by 1.

Related topics:
dec //goto :dec
//end inc

//ff
//:input
input
-------------------------------------------------------------------------------


    <text> \\/input <varible name>, <maximum length>, [<minimum length>],
        [<caps lock flag>], [<mask character>], [<file>][:<link>], [<line>]

Marks the current text line as an input line using specified parameters.

When a line is marked as an input line, a user can select it and input data 
into the specified variable.  When entering data, the default answer is the 
current variable contents, so you might want to clear the variable before 
using this command.  The minimum length is defaulted to 0, the caps lock flag 
(boolean expression) is defaulted to false, and the mask character is 
normally disabled (when a mask character is specified, that character will be 
echoed to the user instead of the actual string.)

If a link is specified, then control will get to that link right after the 
data input is done.

    Please input your name: \\/input name, 30
    Hello, \\&(name)!

Related topics:
edit //goto :edit
readkey //goto :readkey
//end input

//ff
//:locase
locase
-------------------------------------------------------------------------------


    \\/locase <variable name>

Converts a variable value into lower case.

Related topics:
upcase //goto :upcase
//end locase

//ff
//:locate
locate (gotoxy)
-------------------------------------------------------------------------------


    \\/locate <column>, <row>
    \\/gotoxy <column>, <row>

Sets the current cursor position.

This command will locate the cursor at the specified row, column in 
accordance with the current window coordinates.

Related topics:
window //goto :window
//end locate

//ff
//:pop
pop
-------------------------------------------------------------------------------


    \\/pop

Pops a link name out of the stack.

The stack contains the names of all the links that are currently pushed.  
This command will remove the one on the top, just like pressing Escape would 
do.

Related topics:
push //goto :push
//end pop

//ff
//:push
push
-------------------------------------------------------------------------------


    \\/push [[<file>][:<link>]]

Pushes a link name into the stack.

The stack contains the names of all the links that are currently pushed.  
This command will put a new one on the top.

This is especially useful when you want the control to return on the current 
article when pressing Escape in a sub-article.

    \\/:menu
    Option 1 \\/goto :option1
    Option 2 \\/goto :option2
    \\/push
    \\/end menu

Related topics:
goto //goto :goto
pop //goto :pop
savepos //goto :savepos
//end push

//ff
//:quit
quit
-------------------------------------------------------------------------------


    \\/quit
    <text> \\/quit

Quits the Browser interpreter or marks the current line as a quitting line.

The first method simply ends Browser, just like Alt-X would normally do.  
Using the second method, Browser will end if the user selects the quitting 
line.
//end quit

//ff
//:readkey
readkey
-------------------------------------------------------------------------------


    \\/readkey <variable name>[, <echo flag>]

Waits for a keypress and puts the key into the specified variable.

When the echo flag is enabled (default), the character pressed will echo on 
the screen.

Related topics:
edit //goto :edit
input //goto :input
//end readkey

//ff
//:run
run
-------------------------------------------------------------------------------


    \\/run [<file>][:<link>]
    <text> \\/run [<file>][:<link>]

Runs a subprocess.

This command won't use the text interpreter nor load any text into the 
memory, it will simply interpret the commands, one after one.  It is 
especially useful when creating interface procedures in another file 
(normally called the core file.)

The rules for a subprocess are the same as for a normal link, excepted that 
any text in it will be ignored, and that control will return to where it was 
called.
//end run

//ff
//:savepos
savepos
-------------------------------------------------------------------------------


    \\/savepos

Marks the current link in the position-saving mode.

When used, the position-saving mode will remember of the bar position in the 
text as it was when another text gets loaded, so that when the user comes 
back in the first text, reading starts back exactly at the same position.  It 
is best used when in conjunction with a \\/push.

Related topics:
push //goto :push
//end savepos

//ff
//:set
set
-------------------------------------------------------------------------------


    \\/set <variable name>[, <expression>]

Sets the value of a specified variable.

When the expression is not specified or is empty, the variable name is 
cleared from memory.  However, it can still be referenced, although its value 
will be set to an empty string, a numeric zero or a boolean false, depending 
on the expression type.
//end set

//ff
//:setcolor
setcolor (setcolors)
-------------------------------------------------------------------------------


    \\/setcolor <normal foreground>, <normal background>, 
        <normal bar foreground>, <normal bar background>, <link foreground>, 
        <link background>, <link bar foreground>, <link bar background>

Sets the current reader interface colors.

The foreground colors can be one of those:

    0  Black        4  Red          8  Dark Grey    12 Light Red
    1  Blue         5  Magenta      9  Light Blue   13 Light Magenta
    2  Green        6  Brown        10 Light Green  14 Yellow
    3  Cyan         7  Light Grey   11 Light Cyan   15 White

The background colors can be one of those:

    0  Black        2  Green        4  Red          6  Brown
    1  Blue         3  Cyan         5  Magenta      7  Light Grey

The current interface colors are stored in the following variables:

    Normal foreground: \\&(fnorm)  with bar: \\&(fnormbar)
    Normal background: \\&(bnorm)  with bar: \\&(bnormbar)
    Link foreground: \\&(flink)  with bar: \\&(flinkbar)
    Link background: \\&(blink)  with bar: \\&(blinkbar)

Related topics:
color //goto :color
//end setcolor

//ff
//:setcr
setcr
-------------------------------------------------------------------------------


    \\/setcr [<file>][:<link>], [<line>], <flag>

Sets a trap link for the Enter (CR) key.

When this command is enabled (The flag has to specify "true"), any occurance 
of a CR key strike will give control to the specified link.

Related topics:
setesc //goto :setesc
//end setcr

//ff
//:setesc
setesc
-------------------------------------------------------------------------------


    \\/setesc [<file>][:<link>], [<line>], <flag>

Sets a trap link for the Escape key.

When this command is enabled (The flag has to specify "true"), any occurance 
of a Escape key strike will give control to the specified link.

The use of \\/push is strongly recommended instead of this command.

Related topics:
push //goto :push
setcr //goto :setcr
//end setesc

//ff
//:setloadproc
setloadproc (setloadmsg)
-------------------------------------------------------------------------------


    \\/setloadproc <flag>, [<command>]
    \\/setloadmsg <flag>, [<command>]

Sets the text loading command.

The specified commands will be ran whenever a text is loaded (when the flag 
is set to true) or finished loading (when the flag is false).  A \\/run 
command is normally specified when creating a complex interface.  The 
following variables can also be used: \\&(fulllink), \\&(file) and \\&(link).

Related topics:
run //goto :run
setsaveproc //goto :setsaveproc
//end setloadproc

//ff
//:setsaveproc
setsaveproc (setsavemsg)
-------------------------------------------------------------------------------


    \\/setsaveproc <flag>, [<command>]
    \\/setsavemsg <flag>, [<command>]

Sets the text saving command.

The specified commands will be ran whenever the \\/submit command is called 
(when the flag is set to true) or when the text is finished writing (when the 
flag is false).  A \\/run command is normally specified when creating a 
complex interface, and the \\&(savefile) variable, which contains the name of 
the saved file, can be used.

Related topics:
run //goto :run
setloadproc //goto :setloadproc
//end setsaveproc

//ff
//:string
string
-------------------------------------------------------------------------------


    \\/string <numeric expression>, <character>

Echoes a string of characters to the screen.

This command is especially useful when used to draw straight lines -- 
Normally when drawing an interface. The string is echoed at the current 
position, using the defined colors, in accordance with the current window 
coordinates.

Related topics:
color //goto :color
cr //goto :cr
locate //goto :locate
write //goto :write
window //goto :window
//end string

//ff
//:submit
submit
-------------------------------------------------------------------------------


    <text> \\/submit <file>

Marks the current line as a submitting line.

When a submitting line is selected, the current article is written to the 
specified file.

Related topics:
edit //goto :edit
input //goto :input
//end submit

//ff
//:upcase
upcase
-------------------------------------------------------------------------------


    \\/upcase <variable name>

Converts a variable value into upper case.

Related topics:
locase //goto :locase
//end upcase

//ff
//:window
window
-------------------------------------------------------------------------------

    \\/window <column 1>, <row 1>, <column 2>, <row 2>

Sets the current window coordinates.

The current window coordinates are stored in the following variables:

    Lower-right corner: (\\&(wx2), \\&(wy2))
    Upper-left corner: (\\&(wx1), \\&(wy1))

Related topics:
clreol //goto :clreol
clrscreen //goto :clrscreen
locate //goto :locate
//end window

//ff
//:write
write
-------------------------------------------------------------------------------


    \\/write <string expression>

Echoes a string expression to the screen.

The string is echoed at the current position, using the defined colors, in 
accordance with the current window coordinates.

Related commands:
color //goto :color
cr //goto :cr
locate //goto :locate
string //goto :string
window //goto :window
//end write

//ff
//:func
Functions
-------------------------------------------------------------------------------


exist       Tests for the existence of a file. //goto :exist
equ         Tests for the equality between two expressions. //goto :equ
fix         Fixes a string expression to make it fit into a specific //goto :fix
            length, cutting it or adding extra spaces if necessary. //goto :fix
not         Evaluates the negation of a boolean expression. //goto :not
//savepos
//push
//end func

//ff
//:exist
exist
-------------------------------------------------------------------------------


    \\&exist(<file>)

Tests for the existence of a file.

Return: Boolean expression.
//end exist

//ff
//:equ
equ
-------------------------------------------------------------------------------


    \\&equ(<expression 1>, <expression 2>)

Tests for the equality between two expressions

Return: Boolean expression.
//end equ

//ff
//:fix
fix
-------------------------------------------------------------------------------


    \\&fix(<length>, <string expression>)

Fixes a string expression to make it fit into a specific length, cutting it 
or adding extra spaces if necessary.

Return: String expression.
//end fix

//ff
//:not
not
-------------------------------------------------------------------------------


    \\&not(<boolean expression>)

Evaluates the negation of a boolean expression.

Return: Boolean expression.
//end not

//ff
//:error
Errors
-------------------------------------------------------------------------------


0       Not enough variable space for variable <variable name>
1       Not enough position space for link <file>:<link>
2       Out of stack space
3       Unable to expand string
4       Bad file name or file not found: <file>
5       Invalid index or index not found: <file>:<link>
//end error
